=== debian/changelog ===
gofigure2 (0.8.4-1) unstable; urgency=low

  * New upstream
  * Update gofigure2.desktop (upstream)
  * Fix Vcs-Browser URL 
  * Remove all patches

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Thu, 10 Nov 2011 21:03:37 +0100
